<?php

/*
Plugin Name: blau direkt
Plugin URI: http://blog.blaudirekt.de/
Description: Fuegen Sie die Vergleichsrechner von blau direkt in Ihren Blog ein.
Version: 2.1
Author: Dionera GmbH - Hannes Heilenkoetter
Author URI: https://www.blaudirekt.de/hannes-heilenkoetter
Lizenz: GNU General Public License
*/

function buffer_start() { ob_start("callback"); }
function buffer_end() { ob_end_flush(); }
add_filter('the_content', 'replaceRechner');
add_action('wp_head', 'addStyle');
add_action('get_header', 'buffer_start');
add_action('wp_head', 'buffer_end');

function callback($buffer) {
	$GLOBALS['dio.rechner.attributes'] = array('xmlns="http://www.w3.org/1999/xhtml"','xmlns:dio="http://docs.dionera.com/namespace/DioML"');
	return preg_replace_callback('/(<html)([^>]+)(>)/', function($match) {
		$arr=null;
		if(preg_match_all('/([\w\-.:]+)\s*=\s*("[^"]*"|\'[^\']*\'|[\w\-.:]+)/', $match[2],$arr)) {
			foreach($arr[0] as $attribute){
				$GLOBALS['dio.rechner.attributes'][]=$attribute;
			}
		}
		return $match[1].' '.implode(' ',  array_unique($GLOBALS['dio.rechner.attributes'])).$match[3];
	}, $buffer);
}

function replaceRechner($out) {
	$i = 0;
	preg_match_all('/\[RECHNER:(?<rechner>.*?)\]/',$out,$matches);
	if(count($matches) >= 1) {
		foreach($matches['rechner'] as $match) {
			$out = preg_replace(
				'/\[RECHNER:'.$match.'\]/',
				'<div id="calculator-container-'.strtolower($match).'-'.$i.'" style="max-width: 800px; min-width: 450px;">'
                                . '<script src="https://www.maklerinfo.biz/js/api-1.1.js#'.get_option('blau_vermittler').'/create/rechner/'.strtolower($match).'/'.get_option('blau_theme').'" type="text/javascript"></script>'
				. '</div>',
				$out,
				1
			);
			$i++;
		}
	}
	return $out;
}

function addStyle() {
	$out = '';
	if(get_option('blau_css') != '') {
		$out .= '<style type="text/css">';
			$out .= get_option('blau_css');
		$out .= '</style>';
	}
	echo $out;
}

if ('insert' == $_POST['action']) {
	update_option('blau_vermittler',$_POST['blau_vermittler']);
	update_option('blau_css',$_POST['blau_css']);
	update_option('blau_theme',$_POST['blau_theme']);
}

function getAdminMenue() {
	$out = '<div class="wrap">';
		$out .= '<div id="icon-options-general" class="icon32"><br /></div>';
		$out .= '<h2>Einstellungen &rsaquo; blau direkt Vergleichsrechner</h2>';
		$out .= '<form name="form1" method="post" action="'.$location.'">';
			$out .= '<table class="form-table">';
				$out .= '<tr>';
					$out .= '<th>Vermittler-Nummer:</th>';
					$out .= '<td><input name="blau_vermittler" value="'.get_option('blau_vermittler').'" type="text" maxlength="6" style="width: 65px;" /></td>';
				$out .= '</tr>';
				$out .= '<tr>';
					$out .= '<th>Theme:</th>';
					$out .= '<td><input name="blau_theme" value="'.get_option('blau_theme').'" type="text" maxlength="4" style="width: 50px;" /></td>';
				$out .= '</tr>';
				$out .= '<tr>';
					$out .= '<th>CSS:</th>';
					$out .= '<td><textarea name="blau_css" style="width: 700px; height: 100px;">'.get_option('blau_css').'</textarea></td>';
				$out .= '</tr>';
				$out .= '<tr>';
					$out .= '<th></th>';
					$out .= '<td><input type="submit" value="Speichern" class="button-primary" /></td>';
				$out .= '</tr>';
			$out .= '</table>';
			$out .= '<input name="action" value="insert" type="hidden" />';
		$out .= '</form>';
	$out .= '</div>';
	echo $out;
}

function addAdminStep() {
	add_option('blau_vermittler','');
	add_option('blau_theme','');
	add_option('blau_css','');
	add_options_page('blau direkt Vergleichsrechner', 'blau direkt Vergleichsrechner', 9, __FILE__, 'getAdminMenue');
}

add_action('admin_menu','addAdminStep');

?>